unit unit_tasktray;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, iniFiles, Menus, shellapi, ShlObj;

const
  WM_NotifyTasktray = WM_USER + 100;

type
  TKujiraTasktray = class
  private
    IsLiveTasktray: boolean;
    NotifyIcon: TNotifyIconData;
    FMainForm: TForm;
    FTip: string;
    FOnLeftClick  : TNotifyEvent;
    FOnRightClick : TNotifyEvent;
    RegWinMsg: Cardinal;
    FIcon: TIcon;
    procedure ChangeTip(const Value: string);
  public
    IconStatus: Integer; // RɎg
    constructor Create(MainForm: TForm; Tip: string; Icon: TIcon);
    destructor Destroy;override;
    procedure WndProc(var Message: TMessage); // MainFormŌĂł炤
    procedure InitTasktray;
    procedure FinishTasktray;
    procedure EditTasktray;
    procedure ChangeIcon(Icon: TIcon);
    property OnLeftClick: TNotifyEvent read FOnLeftClick write FOnLeftClick;
    property OnRightClick: TNotifyEvent read FOnRightClick write FOnRightClick;
    property Tip: string read FTip write ChangeTip;
    procedure RedrawTray;
  end;


implementation

{ TKujiraTasktray }

procedure TKujiraTasktray.ChangeIcon(Icon: TIcon);
begin
  FIcon := Icon;
  EditTasktray;
end;

procedure TKujiraTasktray.ChangeTip(const Value: string);
begin
  FTip := Value;
  EditTasktray;
end;

constructor TKujiraTasktray.Create(MainForm: TForm; Tip: string; Icon: TIcon);
begin
  // GNXv[[̍ċNo
  RegWinMsg := RegisterWindowMessage('TaskbarCreated');
  //
  IsLiveTaskTray := False;
  //
  FTip      := Tip;
  FMainForm := MainForm;
  FIcon := Icon;
  //
  IconStatus := -777;
end;

destructor TKujiraTasktray.Destroy;
begin
  if IsLiveTasktray then
  begin
    FinishTasktray;
  end;
  inherited;
end;

procedure TKujiraTasktray.EditTasktray;
var
  B: Boolean;
  i: Integer;
begin
  with NotifyIcon do
  begin
      cbSize := SizeOf(NotifyIcon);
      Wnd := FMainForm.Handle;
      uID := 1;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      uCallbackMessage := WM_NotifyTasktray;
      hIcon := FIcon.Handle;
      if FTip <> '' then
        StrLCopy(szTip, PChar(FTip), 63)
      else
        szTip[0] := #0;
  end;

{
http://support.microsoft.com/kb/418138/JA
̓lAvP[Vł̑ΏƂẮAȉ̂悤Ȃ̂l܂B

Shell_NotifyIcon() ̌Ăяo FALSE ԂAGetLastError() ̒l
ERROR_TIMEOUT ꍇ

1. Sleep() ȂǂŁAgC܂ł̊ԁAҋ@܂
2. NIM_MODIFY w肵 Shell_NotifyIcon() ĂяoA
   Shell_NotifyIcon()  FALSE ԂƂmF܂
   (TRUE Ԃꍇɂ́AȑO̓o^ɍsĂ̂Ɣf܂)
3. NIM_ADD w肵 Shell_NotifyIcon() Ăяo܂B
   FALSE Ԃꂽꍇɂ́A1 ̎菇JԂ܂B
}

  // ȑOo^Ă邩H
  B := Shell_NotifyIcon(NIM_MODIFY, @NotifyIcon);

  if B = False then
  begin
    // VKo^
    B := Shell_NotifyIcon(NIM_ADD, @NotifyIcon);
    if B then
    begin
      IsLiveTasktray := True;
    end else
    begin
      for i := 0 to 30 do
      begin
        if GetLastError <> ERROR_TIMEOUT then Break;
        Sleep(500); // (1)
        B := Shell_NotifyIcon(NIM_MODIFY, @NotifyIcon); //(2)
        if B then
        begin
          IsLiveTasktray := True;
          Break;
        end;
        B := Shell_NotifyIcon(NIM_ADD, @NotifyIcon); // (3)
        if B then
        begin
          IsLiveTasktray := True;
          Break;
        end;
      end;
    end;
  end;

  Shell_NotifyIcon(NIM_MODIFY,@NotifyIcon);
  IsLiveTasktray := B;

  // ʒm̈̍ĕ`v
  RedrawTray;
end;

procedure TKujiraTasktray.FinishTasktray;
begin
  if IsLiveTasktray = False then exit;
  with NotifyIcon do
  begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := FMainForm.Handle;
    uID := 1;
  end;
  Shell_NotifyIcon(NIM_DELETE,@NotifyIcon);
  IsLiveTasktray := False;
end;

procedure TKujiraTasktray.InitTasktray;
begin
  if IsLiveTasktray then exit;
  EditTasktray;
end;


procedure TKujiraTasktray.RedrawTray;
var
  h, ch, cch, toolh: THandle;
begin
  h := FindWindow('Shell_TrayWnd', nil);
  if h <> 0 then
  begin
    ch := FindWindowEx(h, 0, 'TrayNotifyWnd', nil);
    if ch <> 0 then
    begin
      cch := FindWindowEx(ch, 0, 'SysPager', nil);
      if cch <> 0 then
      begin
        toolh := FindWindowEx(cch, 0, 'ToolbarWindow32', nil);
        if toolh <> 0 then
        begin
          //
        end;
      end;
    end;
  end;
end;

procedure TKujiraTasktray.WndProc(var Message: TMessage);
begin
  if Message.Msg = WM_NotifyTasktray then
  begin
    case Message.LParam of
      WM_LBUTTONDOWN:
      begin
        // SHIFT + CLICK
        if (GetAsyncKeyState(VK_SHIFT) and $8000) > 0 then
        begin
          if Assigned(FOnRightClick) then FOnRightClick(Self);
        end else
        // CLICK
        begin
          if Assigned(FOnLeftClick) then FOnLeftClick(Self);
        end;
      end;
      WM_RBUTTONDOWN:
      begin
        if Assigned(FOnRightClick) then FOnRightClick(Self);
      end;
    end;
  end else
  if Message.Msg = RegWinMsg then
  begin
    // GNXv[[IĂ܂ꍇ
    try
      EditTasktray;
    except
    end;
  end;

end;

end.
